--- linux-linaro-3.4-2012.05-1_original/arch/arm/kernel/sw_ipi.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/kernel/sw_ipi.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,246 @@
+#include <linux/slab.h>
+#include <linux/module.h>
+#include <linux/io.h>
+#include <linux/sw_ipi.h>
+#include <linux/interrupt.h>
+#include <linux/virtio_mmio.h>
+#include <asm/smp.h>
+#include <asm/cacheflush.h>
+
+#define VIRTIO_NET_IPI_NUM 0x10
+
+struct ipi_shared_mem_info {
+	void* sw_ipi_pri_data;
+	int sw_ipi_pri_data_size;
+	char* sw_ipi_bit_map;
+	char* sw_ipi_bit_map_end;
+};
+
+static struct ipi_shared_mem_info ipi_sh_mem_info;
+static struct workqueue_struct* ipi_work_queue;
+static struct list_head sw_ipi_hndl_list;
+static unsigned int cacheline_size;
+struct sw_ipi_handlers{
+    struct list_head head;
+    int ipi_num;
+    work_func_t ipi_hndl;
+	int irq_num;
+	void *data;
+};
+
+#define SMC_CMD_GET_IPI_DAT_SHMEM_ADDR  (-40)
+#define SMC_CMD_GET_IPI_DAT_SHMEM_SIZE  (-41)
+#define SMC_CMD_GET_IPI_BIT_SHMEM_ADDR  (-42)
+#define SMC_CMD_GET_IPI_BIT_SHMEM_SIZE  (-43)
+
+static void sw_inv_range(unsigned long start, unsigned long end)
+{
+	start = round_down(start, cacheline_size);
+	end = round_up(end, cacheline_size);
+	while (start < end) {
+		asm ("mcr p15, 0, %0, c7, c6, 1" : : "r" (start)
+				: "memory");
+		start += cacheline_size;
+	}
+	dsb();
+	isb();
+}
+
+u32 sw_send_smc(u32 cmd, u32 arg1, u32 arg2, u32 arg3)
+{
+    register u32 reg0 __asm__("r0") = cmd;
+    register u32 reg1 __asm__("r1") = arg1;
+    register u32 reg2 __asm__("r2") = arg2;
+    register u32 reg3 __asm__("r3") = arg3;
+
+    __asm__ volatile (
+		".arch_extension sec\n"
+        "smc    0\n"
+        : "+r"(reg0), "+r"(reg1), "+r"(reg2), "+r"(reg3)
+    );
+
+    return reg0;
+}
+
+static int get_ipi_num(void)
+{
+    int ipi_num = 0;
+    char* bit_map, bit_val;
+
+	clean_dcache_area((void *)&ipi_sh_mem_info, sizeof(ipi_sh_mem_info));
+	/*sw_inv_range((unsigned long)&ipi_sh_mem_info , (unsigned
+			long)&ipi_sh_mem_info + sizeof(ipi_sh_mem_info));*/
+	bit_map = ipi_sh_mem_info.sw_ipi_bit_map;
+
+   while(!(*bit_map)){
+        ipi_num += 8;
+        bit_map++;
+		if((int)bit_map >= (int)ipi_sh_mem_info.sw_ipi_bit_map_end){
+       		printk("Invalid ipi number\n");	
+		return -1;
+		}
+    }
+	bit_val = *bit_map;
+
+    while(!(bit_val & 1)){
+        ipi_num++;
+        bit_val >>= 1;
+    }
+
+    return ipi_num;
+}
+
+static void reset_ipi(int ipi_num)
+{
+	char* bit_map;
+
+	bit_map = ipi_sh_mem_info.sw_ipi_bit_map;
+
+	while(ipi_num > 7){
+		ipi_num -= 8;
+		bit_map++;
+	}
+	*bit_map = (*bit_map) & (~(1 << ipi_num));
+}
+
+
+int hyp_notify_handler(unsigned int irq, void (*handler) (struct work_struct *),
+		unsigned long irqflags, const char *devname, void *dev_id)
+{
+	int err;
+#ifdef CONFIG_SW_A15_HYP
+	err = request_irq(irq, vm_interrupt, irqflags, devname, dev_id);
+	if (err)
+		return err;
+#else
+	err = sw_register_ipi_handler(VIRTIO_NET_IPI_NUM, irq, handler, dev_id);	
+	if (err) { 
+		printk(KERN_ALERT "Unable to register ipi handler\n");
+		return err;
+	}
+	printk(KERN_ALERT "IPI handler registered successfully\n");
+#endif
+	return 0;
+}
+
+static void sw_ns_ipi_handler(struct pt_regs *regs)
+{
+    int ipi_num;
+    struct sw_ipi_info *new_wq;
+    struct sw_ipi_handlers *tem_handler;
+    int ipi_hndl_found = 0;
+
+    ipi_num = get_ipi_num();
+	if(ipi_num < 0){
+		return;
+	}
+	reset_ipi(ipi_num);
+    list_for_each_entry(tem_handler, &sw_ipi_hndl_list, head) {
+        if(tem_handler->ipi_num == ipi_num){
+            ipi_hndl_found = 1;
+            break;
+        }
+    }
+    if(!ipi_hndl_found){
+        printk(KERN_ALERT "Could not find registered handler for this ipi\n");
+        return;
+    }
+    new_wq = (struct sw_ipi_info*)kmalloc(sizeof(struct sw_ipi_info) ,GFP_KERNEL);
+    if(!new_wq){
+        printk("Allocation of work queue failed for the ipi %d\n",ipi_num);
+        return;
+    }
+	if(ipi_num == VIRTIO_NET_IPI_NUM) {
+		new_wq->irq_num = tem_handler->irq_num;
+	new_wq->pri_data = tem_handler->data;
+	}
+	else {
+		new_wq->pri_data = (char*)kmalloc(ipi_sh_mem_info.sw_ipi_pri_data_size, GFP_KERNEL);
+    	if(!new_wq->pri_data){
+        	printk("Allocation of buffer for copying the shared mem failed"
+				" for the ipi %d\n",ipi_num);
+			kfree(new_wq);
+     	  	return;
+   		 }
+
+		 memcpy(new_wq->pri_data, ipi_sh_mem_info.sw_ipi_pri_data, 
+			ipi_sh_mem_info.sw_ipi_pri_data_size);
+	}
+	INIT_WORK(&new_wq->work , tem_handler->ipi_hndl);
+	queue_work(ipi_work_queue, &new_wq->work);
+	return;
+}
+
+int sw_register_ipi_handler(int ipi_num, int irq, void* func, void *data)
+{
+	struct sw_ipi_handlers* new_handler;
+	static int wq_create = 0;
+
+	if(!wq_create){
+		printk("*** Creating work queue *** \n");
+		ipi_work_queue = create_workqueue("sw_ipi_handler");
+		wq_create = 1;
+	}
+
+	new_handler = (struct sw_ipi_handlers*)kmalloc(sizeof(struct sw_ipi_handlers), GFP_KERNEL);
+	if(!new_handler){
+		printk("Failed to allocate memory for the new handler registration \n");
+		printk("Failed to register the ipi handler %d \n",ipi_num);
+		return -ENOMEM;
+	}
+
+	INIT_LIST_HEAD(&new_handler->head);
+	new_handler->ipi_num = ipi_num;
+	new_handler->ipi_hndl = func;
+	new_handler->data = data;
+	new_handler->irq_num = irq;
+	list_add(&new_handler->head, &sw_ipi_hndl_list);
+	return 0;
+}
+EXPORT_SYMBOL(sw_register_ipi_handler);
+
+void sw_unregister_ipi_handler(int ipi_num)
+{
+	int ipi_hndl_found = 0;
+	struct sw_ipi_handlers *tem_handler;
+	list_for_each_entry(tem_handler, &sw_ipi_hndl_list, head) {
+		if(tem_handler->ipi_num == ipi_num){
+			ipi_hndl_found = 1;
+			break;
+		}
+	}
+	if(ipi_hndl_found){
+		list_del(&tem_handler->head);
+		kfree(tem_handler);
+	}
+}
+EXPORT_SYMBOL(sw_unregister_ipi_handler);
+
+void sw_ipi_handler_init(void)
+{
+	unsigned int sh_mem_addr,sh_mem_size;
+	unsigned long ctr;
+	
+	asm volatile("mrc p15, 0, %0, c0, c0, 1" : "=r" (ctr));
+	cacheline_size =  4 << ((ctr >> 16) & 0xf);
+
+	printk("*** Initializing sw ipi handler *** \n");
+	register_secure_notify_handler(sw_ns_ipi_handler);
+
+	/* Registering shared memory for ipi handling */
+	sh_mem_addr = sw_send_smc(SMC_CMD_GET_IPI_DAT_SHMEM_ADDR, 0, 0, 0);
+	ipi_sh_mem_info.sw_ipi_pri_data_size = sw_send_smc(SMC_CMD_GET_IPI_DAT_SHMEM_SIZE, 0, 0, 0);
+	printk(KERN_ALERT "IPI_DATA_SHMEM_ADDR = 0x%08x  *** \n", sh_mem_addr);
+	printk(KERN_ALERT "IPI_DATA_SHMEM_SIZE = 0x%08x  *** \n", ipi_sh_mem_info.sw_ipi_pri_data_size);
+	ipi_sh_mem_info.sw_ipi_pri_data = (void *)ioremap(sh_mem_addr,
+			ipi_sh_mem_info.sw_ipi_pri_data_size);
+
+	sh_mem_addr = sw_send_smc(SMC_CMD_GET_IPI_BIT_SHMEM_ADDR, 0, 0, 0);
+	sh_mem_size = sw_send_smc(SMC_CMD_GET_IPI_BIT_SHMEM_SIZE, 0, 0, 0);
+	ipi_sh_mem_info.sw_ipi_bit_map = (char *)ioremap(sh_mem_addr, sh_mem_size);
+	ipi_sh_mem_info.sw_ipi_bit_map_end = ipi_sh_mem_info.sw_ipi_bit_map + sh_mem_size;
+	printk(KERN_ALERT "IPI_BIT_SHMEM_ADDR = 0x%08x  *** \n", sh_mem_addr);
+	printk(KERN_ALERT "IPI_BIT_SHMEM_SIZE = 0x%08x  *** \n", sh_mem_size);
+	INIT_LIST_HEAD(&sw_ipi_hndl_list);
+}
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/clock.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/clock.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/clock.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/clock.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,148 @@
+#include <linux/clk-private.h>
+#include <linux/clkdev.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <asm/timex.h>
+#include <linux/interrupt.h>
+#include <mach/hardware.h>
+#include <asm/hardware/cache-l2x0.h>
+#include <linux/irq.h>
+#include <asm/hardware/gic.h>
+#include <asm/cacheflush.h>
+#include <mach/cnc1900_clock_reg.h>
+
+#define PLL_CLK_EN      0x0140 
+#define SOFT_RESET      0x0200 
+#define OTG_CTRL	0x0390 
+
+extern unsigned int cnc1900_get_cpufreq(void);
+
+static void __iomem *iomem;
+
+static struct clk_ops pclk_ops = {
+};
+
+static struct clk pclk = {
+	.flags = CLK_IS_ROOT,
+	.rate = PCLK_FREQ / 2,
+	.ops = &pclk_ops,
+};
+
+static int mmc_enable(struct clk_hw *hw)
+{
+	u32 val = __raw_readl(iomem + PLL_CLK_EN);
+
+	val |= 0x00000080;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+	return 0;	
+}
+
+static void mmc_disable(struct clk_hw *hw)
+{
+	u32 val = __raw_readl(iomem + PLL_CLK_EN);
+
+	val &= ~0x00000080;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+}
+
+static struct clk_ops mmc_ops = {
+	.enable = mmc_enable,
+	.disable = mmc_disable,
+};
+
+static struct clk mmc_clk = {
+	.parent = &pclk,
+	.ops = &mmc_ops,
+};
+
+static int hci_enable(struct clk_hw *hw)
+{
+	u32 val;
+	
+	val = __raw_readl(iomem + PLL_CLK_EN);
+	val |= 0x02000000;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+	udelay(100);
+
+	val = __raw_readl(iomem + SOFT_RESET);
+	val |= 0xEB800000;
+	__raw_writel(val, iomem + SOFT_RESET);
+	udelay(100);
+	return 0;
+}
+
+static void hci_disable(struct clk_hw *hw)
+{
+	u32 val = __raw_readl(iomem + PLL_CLK_EN);
+
+	val &= ~0x02000000;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+}
+
+static struct clk_ops hci_ops = {
+	.enable = hci_enable,
+	.disable = hci_disable,
+};
+
+static struct clk hci_clk = {
+	.parent = &pclk,
+	.ops = &hci_ops,
+};
+
+static int otg_enable(struct clk_hw *hw)
+{
+	u32 val;
+	
+	val = __raw_readl(iomem + PLL_CLK_EN);
+	val |= 0x02000000;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+	udelay(100);
+
+	val = __raw_readl(iomem + SOFT_RESET);
+	val |= 0x55800000;
+	__raw_writel(val, iomem + SOFT_RESET);
+	udelay(100);
+
+	__raw_writel(0x1, iomem + OTG_CTRL);
+	udelay(100);
+	return 0;
+}
+
+static void otg_disable(struct clk_hw *hw)
+{
+	u32 val = __raw_readl(iomem + PLL_CLK_EN);
+
+	val &= ~0x02000000;
+	__raw_writel(val, iomem + PLL_CLK_EN);
+}
+
+static struct clk_ops otg_ops = {
+	.enable = otg_enable,
+	.disable = otg_disable,
+};
+
+static struct clk otg_clk = {
+	.parent = &pclk,
+	.ops = &otg_ops,
+};
+
+static struct clk_lookup lookups[] = {
+	CLKDEV_INIT("smp_gbl",     NULL, &pclk),
+	CLKDEV_INIT("smp_twd",     NULL, &pclk),
+	CLKDEV_INIT("dw_spi_mmio", NULL, &pclk),
+	CLKDEV_INIT("dw_mmc.0",    NULL, &mmc_clk),
+	CLKDEV_INIT("dw_mmc.1",    NULL, &mmc_clk),
+	CLKDEV_INIT("ehci-platform", NULL, &hci_clk),
+	CLKDEV_INIT("dwc_otg", NULL, &otg_clk),
+};
+
+unsigned int cnc1900_get_cpufreq(void);
+
+void __init plat_clock_init(void)
+{
+	iomem = ioremap(CNC1900_ID_SCS, CLOCK_REG_SIZE);
+	pclk.rate = cnc1900_get_cpufreq() / 2;
+
+	clk_prepare(&pclk);
+	clkdev_add_table(lookups, ARRAY_SIZE(lookups));
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc1900_cpufreq_plat.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc1900_cpufreq_plat.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc1900_cpufreq_plat.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc1900_cpufreq_plat.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,168 @@
+#include <linux/clk-private.h>
+#include <linux/clkdev.h>
+#include <linux/delay.h>
+#include <linux/io.h>
+#include <asm/timex.h>
+#include <linux/interrupt.h>
+#include <mach/hardware.h>
+#include <asm/hardware/cache-l2x0.h>
+#include <linux/irq.h>
+#include <asm/hardware/gic.h>
+#include <asm/cacheflush.h>
+#include <asm/div64.h>
+#include <mach/cnc1900_clock_reg.h>
+
+#define CPUFREQ_ADJUST_IRQ 81
+
+const u32 pll_cpu_div_qv[4] = {1, 2, 4, 6};
+
+unsigned int timer_prescaler_val;
+
+unsigned int cnc1900_get_cpufreq(void)
+{
+	u32 pll_cpu_div_f, pll_cpu_div_q;
+	uint64_t freq;
+
+	/* Get default CPU frequency from PLL settings */
+	pll_cpu_div_f = (__raw_readl(IO_ADDRESS(PLL_CPU_DIV)) >> 6) & 0x7f;
+	pll_cpu_div_q = (__raw_readl(IO_ADDRESS(PLL_CPU_DIV)) >> 3) & 0x7;
+
+	freq = 	(unsigned long long)(pll_cpu_div_f + 1) * 54000000LL;
+	do_div(freq, pll_cpu_div_qv[pll_cpu_div_q]);
+	return (uint32_t)freq;
+}
+/*
+ * Some code only need the multiple of current frequency rather than the real frequency,
+ * so I add this function for speed up.
+ */
+unsigned int cnc1900_get_cpufreq_multiple(void)
+{
+	u32 pll_cpu_div_f, pll_cpu_div_q;
+
+	/* Get default CPU frequency from PLL settings */
+	pll_cpu_div_f = (__raw_readl(IO_ADDRESS(PLL_CPU_DIV)) >> 6) & 0x7f;
+	pll_cpu_div_q = (__raw_readl(IO_ADDRESS(PLL_CPU_DIV)) >> 3) & 0x7;
+
+	return (pll_cpu_div_f + 1) * 2 / pll_cpu_div_qv[pll_cpu_div_q];
+}
+
+void cnc1900_set_cpufreq(unsigned int target_freq)
+{
+	extern struct cpu_cache_fns cpu_cache;
+	unsigned int data;
+	unsigned long flags;
+	int i;
+	unsigned int bits_buf[DIV_ROUND_UP(NR_IRQS, 32)]={0};
+    void __iomem *l2x0_base = (void *)IO_ADDRESS(CNC1900_L2X0);
+	void __iomem *dist_base = (void *)IO_ADDRESS(CNC1900_CA9_GIC_DIST);
+	unsigned int wdog_load_val;
+	unsigned int wdog_counter_val;
+	unsigned int twd_load_val;
+	unsigned int twd_counter_val;
+	unsigned int old_cpufreq_multiple;
+	unsigned int ctrl;
+
+	local_irq_save(flags);
+	for (i = 0; i < DIV_ROUND_UP(NR_IRQS, 32); i++)
+		bits_buf[i] = readl_relaxed(dist_base + GIC_DIST_ENABLE_SET + i * 4);
+	for (i = 0; i < DIV_ROUND_UP(NR_IRQS, 32); i++)
+		writel_relaxed(0xFFFFFFFF,dist_base + GIC_DIST_ENABLE_CLEAR + i * 4);
+	writel_relaxed(1 << (CPUFREQ_ADJUST_IRQ % 32),dist_base + GIC_DIST_ENABLE_SET + (CPUFREQ_ADJUST_IRQ / 32) * 4); //only enable interrupt CPUFREQ_ADJUST_IRQ.
+	local_irq_restore(flags);
+
+	data = 0;
+	__asm__ __volatile__(
+	"@invalidate branch predictor\n\t"
+	"mcr p15, 0, %0, c7, c1, 6  @issue the command of invalidate entire branch predictor array inner shareable \n\t"
+	"dsb \n\t"
+	"isb \n\t"
+	:
+	:"r"(data)
+	:);
+
+	//disable dynamic clock gating of L2 cache
+	data = readl(l2x0_base + L2X0_POWER_CTRL);//read power control register of L2 cache
+    data = data & 0xfffffffd;                 //prepare data
+	writel(data, l2x0_base + L2X0_POWER_CTRL);//write power control register of L2 cache
+
+	//set PMU POWER_MODE register to no transaction clock adjustment mode
+	__raw_writel(1,(IO_ADDRESS(CPU_PWR_MODE)));
+
+	target_freq/=27000000;
+	target_freq-=1;
+
+	old_cpufreq_multiple=cnc1900_get_cpufreq_multiple();
+	
+	/* Set new CPU frequency */
+	__raw_writel((target_freq<<6)|0xB,(IO_ADDRESS(PLL_CPU_DIV)));
+
+	__asm__("dsb");
+	__asm__("isb");
+
+	__asm__("wfi");
+	timer_prescaler_val=((cnc1900_get_cpufreq_multiple()-1)<<8);
+	//set PMU POWER_MODE register to normal mode
+	__raw_writel(0,(IO_ADDRESS(CPU_PWR_MODE)));
+
+	//enable dynamic clock gating and standby mode of L2 cache
+	data = readl(l2x0_base + L2X0_POWER_CTRL); //read power control register of L2 cache
+	data = data | 0x3;                         //prepare data
+	writel(data, l2x0_base + L2X0_POWER_CTRL); //write power control register of L2 cache
+
+	local_irq_save(flags);
+	for (i = 0; i < DIV_ROUND_UP(NR_IRQS, 32); i++)
+		writel_relaxed(bits_buf[i],dist_base + GIC_DIST_ENABLE_SET + i * 4);
+	writel_relaxed(1 << (CPUFREQ_ADJUST_IRQ % 32),dist_base + GIC_DIST_ENABLE_CLEAR + (CPUFREQ_ADJUST_IRQ / 32) * 4); //disable interrupt CPUFREQ_ADJUST_IRQ.
+
+	//tune global,private,watchdog timers as the input clock are also changed.
+	wdog_load_val = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_LOAD);
+	wdog_counter_val = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_COUNTER);
+	twd_load_val = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_LOAD);
+	twd_counter_val = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_COUNTER);
+	
+	wdog_load_val = wdog_load_val*cnc1900_get_cpufreq_multiple()/old_cpufreq_multiple;
+	wdog_counter_val = wdog_counter_val*cnc1900_get_cpufreq_multiple()/old_cpufreq_multiple;
+	twd_load_val = twd_load_val*cnc1900_get_cpufreq_multiple()/old_cpufreq_multiple;
+	twd_counter_val = twd_counter_val*cnc1900_get_cpufreq_multiple()/old_cpufreq_multiple;
+
+	__raw_writel(wdog_load_val, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_LOAD);
+	__raw_writel(wdog_counter_val, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_COUNTER);
+	__raw_writel(twd_load_val, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_LOAD);
+	__raw_writel(twd_counter_val, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_COUNTER);
+	
+	ctrl = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_CONTROL);
+	ctrl &= 0xFFFF00FF;
+	ctrl |=timer_prescaler_val;
+	__raw_writel(ctrl, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_WDOG_CONTROL);
+
+	ctrl = __raw_readl(IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_CONTROL);
+	ctrl &= 0xFFFF00FF;
+	ctrl |=timer_prescaler_val;
+	__raw_writel(ctrl, IO_ADDRESS(CNC1900_CA9_TWD) + CAV_TIMER_CONTROL);
+
+	ctrl = __raw_readl(IO_ADDRESS(CNC1900_CA9_GBL_TIMER) + GBL_TIMER_CONTROL);
+	ctrl &= 0xFFFF00FF;
+	ctrl |=timer_prescaler_val;
+	__raw_writel(ctrl, IO_ADDRESS(CNC1900_CA9_GBL_TIMER) + GBL_TIMER_CONTROL);
+
+	local_irq_restore(flags);
+}
+
+static irqreturn_t cnc1900_pmu_interrupt(int irq, void *dev_id)
+{
+	//clear interrupt request
+	__raw_writel(0,(IO_ADDRESS(CPUCLK_ST_INT)));
+	
+	return IRQ_HANDLED;
+}
+
+int cnc1900_cpufreq_plat_init(void)
+{
+	if (request_irq(CPUFREQ_ADJUST_IRQ, cnc1900_pmu_interrupt, 0, "cpufreq_irq", NULL)) {
+		printk(KERN_ERR "cnc1900_cpufreq_driver_init: cannot register cpufreq IRQ \n");
+		return -EIO;
+	}
+	return 0;
+}
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc1900_power_clk.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc1900_power_clk.c
